#ifndef IEC104_H_
#define IEC104_H_

// This is a generated file! Please edit source .ksy file and use kaitai-struct-compiler to rebuild

#include "kaitaistruct.h"

#include <stdint.h>
#include <vector>

#if KAITAI_STRUCT_VERSION < 7000L
#error "Incompatible Kaitai Struct C++/STL API: version 0.7 or later is required"
#endif

class iec104_t : public kaitai::kstruct {

public:
    class iform_t_t;
    class sform_t_t;
    class uform_t_t;
    class asdu_t_t;

    iec104_t(kaitai::kstream* p__io, kaitai::kstruct* p__parent = 0, iec104_t* p__root = 0);

private:
    void _read();

public:
    ~iec104_t();

    class iform_t_t : public kaitai::kstruct {

    public:

        iform_t_t(kaitai::kstream* p__io, iec104_t* p__parent = 0, iec104_t* p__root = 0);

    private:
        void _read();

    public:
        ~iform_t_t();

    private:
        bool f_send_no;
        int32_t m_send_no;

    public:
        int32_t send_no();

    private:
        bool f_rec_no;
        int32_t m_rec_no;

    public:
        int32_t rec_no();

    private:
        uint8_t m_send_no_msb;
        uint64_t m_rec_no_lsb;
        uint64_t m_zero_bit;
        uint8_t m_rec_no_msb;
        iec104_t* m__root;
        iec104_t* m__parent;

    public:
        uint8_t send_no_msb() const { return m_send_no_msb; }
        uint64_t rec_no_lsb() const { return m_rec_no_lsb; }
        uint64_t zero_bit() const { return m_zero_bit; }
        uint8_t rec_no_msb() const { return m_rec_no_msb; }
        iec104_t* _root() const { return m__root; }
        iec104_t* _parent() const { return m__parent; }
    };

    class sform_t_t : public kaitai::kstruct {

    public:

        sform_t_t(kaitai::kstream* p__io, iec104_t* p__parent = 0, iec104_t* p__root = 0);

    private:
        void _read();

    public:
        ~sform_t_t();

    private:
        bool f_rec_no;
        int32_t m_rec_no;

    public:
        int32_t rec_no();

    private:
        uint8_t m_dummy;
        uint64_t m_rec_no_lsb;
        uint64_t m_zero_bit;
        uint8_t m_rec_no_msb;
        iec104_t* m__root;
        iec104_t* m__parent;

    public:
        uint8_t dummy() const { return m_dummy; }
        uint64_t rec_no_lsb() const { return m_rec_no_lsb; }
        uint64_t zero_bit() const { return m_zero_bit; }
        uint8_t rec_no_msb() const { return m_rec_no_msb; }
        iec104_t* _root() const { return m__root; }
        iec104_t* _parent() const { return m__parent; }
    };

    class uform_t_t : public kaitai::kstruct {

    public:

        uform_t_t(kaitai::kstream* p__io, iec104_t* p__parent = 0, iec104_t* p__root = 0);

    private:
        void _read();

    public:
        ~uform_t_t();

    private:
        uint8_t m_dummy1;
        uint64_t m_dummy7;
        uint64_t m_zero_bit;
        uint8_t m_dummy2;
        iec104_t* m__root;
        iec104_t* m__parent;

    public:
        uint8_t dummy1() const { return m_dummy1; }
        uint64_t dummy7() const { return m_dummy7; }
        uint64_t zero_bit() const { return m_zero_bit; }
        uint8_t dummy2() const { return m_dummy2; }
        iec104_t* _root() const { return m__root; }
        iec104_t* _parent() const { return m__parent; }
    };

    class asdu_t_t : public kaitai::kstruct {

    public:

        asdu_t_t(kaitai::kstream* p__io, iec104_t* p__parent = 0, iec104_t* p__root = 0);

    private:
        void _read();

    public:
        ~asdu_t_t();

    private:
        uint8_t m_type_identification;
        bool m_sq;
        uint64_t m_num_of_items;
        bool m_t;
        bool m_p_n;
        uint64_t m_cot;
        uint8_t m_org;
        uint16_t m_address;
        std::vector<uint8_t>* m_items;
        iec104_t* m__root;
        iec104_t* m__parent;

    public:
        uint8_t type_identification() const { return m_type_identification; }
        bool sq() const { return m_sq; }
        uint64_t num_of_items() const { return m_num_of_items; }
        bool t() const { return m_t; }
        bool p_n() const { return m_p_n; }
        uint64_t cot() const { return m_cot; }
        uint8_t org() const { return m_org; }
        uint16_t address() const { return m_address; }
        std::vector<uint8_t>* items() const { return m_items; }
        iec104_t* _root() const { return m__root; }
        iec104_t* _parent() const { return m__parent; }
    };

private:
    std::string m_magic;
    uint8_t m_length;
    uint64_t m_testfr;
    uint64_t m_stopdt;
    uint64_t m_startdt;
    bool m_flag1;
    bool m_flag0;
    iform_t_t* m_iform;
    bool n_iform;

public:
    bool _is_null_iform() { iform(); return n_iform; };

private:
    sform_t_t* m_sform;
    bool n_sform;

public:
    bool _is_null_sform() { sform(); return n_sform; };

private:
    uform_t_t* m_uform;
    bool n_uform;

public:
    bool _is_null_uform() { uform(); return n_uform; };

private:
    asdu_t_t* m_asdu;
    bool n_asdu;

public:
    bool _is_null_asdu() { asdu(); return n_asdu; };

private:
    std::vector<uint8_t>* m_erroneous;
    bool n_erroneous;

public:
    bool _is_null_erroneous() { erroneous(); return n_erroneous; };

private:
    iec104_t* m__root;
    kaitai::kstruct* m__parent;

public:
    std::string magic() const { return m_magic; }
    uint8_t length() const { return m_length; }
    uint64_t testfr() const { return m_testfr; }
    uint64_t stopdt() const { return m_stopdt; }
    uint64_t startdt() const { return m_startdt; }
    bool flag1() const { return m_flag1; }
    bool flag0() const { return m_flag0; }
    iform_t_t* iform() const { return m_iform; }
    sform_t_t* sform() const { return m_sform; }
    uform_t_t* uform() const { return m_uform; }
    asdu_t_t* asdu() const { return m_asdu; }
    std::vector<uint8_t>* erroneous() const { return m_erroneous; }
    iec104_t* _root() const { return m__root; }
    kaitai::kstruct* _parent() const { return m__parent; }
};

#endif  // IEC104_H_
