# IEC-104 protocol
# Author: Dušan Kolář
# 
meta:
  id:      iec104
  endian:  le

seq:
  - id:       magic
    contents: [ 0x68 ]
  - id:       length
    type:     u1
  - id:       testfr
    type:     b2
  - id:       stopdt
    type:     b2
  - id:       startdt
    type:     b2
  - id:       flag1
    type:     b1
  - id:       flag0
    type:     b1
  - id:       iform
    type:     iform_t
    if: flag0 == false
  - id:       sform
    type:     sform_t
    if: flag0 == true  and  flag1 == false
  - id:       uform
    type:     uform_t
    if: flag0 == true  and  flag1 == true
  - id:       asdu
    type:     asdu_t
    if: length > 10
  - id:       erroneous
    type:     u1
    repeat:   eos
    if: length <= 10

types:
  iform_t:
    seq:
      - id:       send_no_msb
        type:     u1
      - id:       rec_no_lsb
        type:     b7
      - id:       zero_bit
        type:     b0
      - id:       rec_no_msb
        type:     u1
    instances:
      send_no:
        value:  (send_no_msb << 7) + (_parent.testfr << 5) + (_parent.stopdt << 3) + (_parent.startdt << 1) + _parent.flag1.to_i
      rec_no:
        value:  (rec_no_msb << 7) + rec_no_lsb

  sform_t:
    seq:
      - id:       dummy
        type:     u1
      - id:       rec_no_lsb
        type:     b7
      - id:       zero_bit
        type:     b0
      - id:       rec_no_msb
        type:     u1
    instances:
      rec_no:
        value:  (rec_no_msb << 7) + rec_no_lsb

  uform_t:
    seq:
      - id:       dummy1
        type:     u1
      - id:       dummy7
        type:     b7
      - id:       zero_bit
        type:     b0
      - id:       dummy2
        type:     u1

  asdu_t:
    seq:
      - id:       type_identification
        type:     u1
      - id:       sq
        type:     b1
      - id:       num_of_items
        type:     b7
      - id:       t
        type:     b1
      - id:       p_n
        type:     b1
      - id:       cot
        type:     b6
      - id:       org
        type:     u1
      - id:       address
        type:     u2
      - id:       items
        type:     u1
        repeat:   eos

# EOF
